use std::sync::mpsc;
use std::thread;

fn main() {
   //let (tx, rx) = mpsc::channel(); // this works, with type inference
   let (tx, rx): (mpsc::Sender<&str>, mpsc::Receiver<&str>) = mpsc::channel();

   thread::spawn(move || {
      tx.send("Hello from thread").unwrap();
      tx.send("Second message").unwrap();
      tx.send("Notice they buffer").unwrap();
      // println!("Received: {}", rx.recv().unwrap());
      // this would cause compile error, since the rx end
      // is owned by the main thread
   });

   println!("Received: {}", rx.recv().unwrap());
   println!("Received: {}", rx.recv().unwrap());
   // tx.send("Notice they buffer").unwrap();
   // this would cause compile error, since the tx end
   // was moved to the spawned thread
}

