use std::sync::{Arc, Mutex};
use std::thread;

fn main() {
    let data = Arc::new(Mutex::new(0)); 

    let handles: Vec<_> = (0..10).map(|_| {
        let data_clone = Arc::clone(&data);  // clone of an address, so the underlying
                                             // data is shared among the threads
        thread::spawn(move || {
            let mut num = data_clone.lock().unwrap();
            *num += 1;
            // lock is released on thread end
        })
    }).collect();

    for handle in handles {
        handle.join().unwrap();
    }

    println!("Final value: {}", *data.lock().unwrap());
}

