
use std::sync::{Arc, atomic::{AtomicUsize, Ordering}};
use std::thread;

fn main() {    
   let counter = Arc::new(AtomicUsize::new(0)); // Wrap AtomicUsize in Arc    
   let mut handles = vec![];    
   for i in 0..300 {        
      let counter = Arc::clone(&counter); // Clone the Arc for each thread        
      let handle = thread::spawn(move || {            
         for _ in 0..500 {                
            // Atomically increment the counter 
            let x = counter.load(Ordering::SeqCst);  // atomic function on the int
            counter.store(x+1,Ordering::SeqCst);  // atomic function on the int
         }        
         println!("thread #{} done",i);
      });       
      handles.push(handle);    
   }    
   // Wait for all threads to finish    
   for handle in handles { handle.join().unwrap(); }    
   println!("Final counter: {}", counter.load(Ordering::SeqCst));
}


