use tokio::time::{sleep, Duration};

#[tokio::main]
async fn main() {
    let handles: Vec<_> = (0..4).map(|i| {
        tokio::spawn(async move {
            println!("Task {} is starting!", i);
            sleep(Duration::from_secs(1)).await;
            println!("Task {} is done!", i);
        })
    }).collect();

    for handle in handles {
        handle.await.unwrap();
    }
}

