
use std::sync::mpsc;
use std::thread;
use std::time::Duration;

fn main() {
    let (ping_tx, ping_rx) = mpsc::channel::<String>();
    let (pong_tx, pong_rx) = mpsc::channel::<String>();

    // Spawn the "ping" thread
    let ping_tx_clone = ping_tx.clone(); // Clone the sender
    thread::spawn(move || {
        for _ in 0..10 {
            thread::sleep(Duration::from_secs(1));
            // Send "Ping" to pong thread
            ping_tx_clone.send("Ping".to_string()).unwrap();

            thread::sleep(Duration::from_millis(500));

            // Receive "Pong" response
            let msg = pong_rx.recv().unwrap();
            println!("Ping received: {}", msg);
        }
    });

    // Spawn the "pong" thread
    thread::spawn(move || {
        for _ in 0..10 {
            thread::sleep(Duration::from_secs(1));
            // Receive "Ping" message
            let msg = ping_rx.recv().unwrap();
            println!("Pong received: {}", msg);

            thread::sleep(Duration::from_millis(500));

            // Send "Pong" back to ping thread
            pong_tx.send("Pong".to_string()).unwrap();
        }
    });

    // Allow threads to finish
    thread::sleep(Duration::from_secs(20));
}

