// basic async func demo
// asyncdemo

use tokio;

#[tokio::main]
async fn main() {
   let task1 = async {  println!("Task 1 starts");
      tokio::time::sleep(std::time::Duration::from_secs(3)).await; // work
      println!("Task 1 ends");
      42
   };

   let foo_fut = foo(); // creates a future, binds it to a variable
                // this does NOT execute the foo fn, that happens at await

   // Run all async tasks concurrently
   let (res1, res2) = tokio::join!(task1, foo_fut); // conc awaits on futures

   println!("Result 1: {}", res1);
   println!("Result 2: {}", res2);
}

async fn foo() -> i32 {  println!("foo task starts");
   tokio::time::sleep(std::time::Duration::from_secs(2)).await; // simulate work
   println!("foo task ends");
   17
}

