
//
// demo of mixing threads and async
//

use tokio;
use std::thread;
use std::time::Duration;

async fn fetch_data() -> String {
    // Simulate async work
    println!("begin future execution...");
    thread::sleep(Duration::from_millis(400));
    "Hello, async world!".to_string()  // returns a string value
}

#[tokio::main]
async fn main() {
    let th = thread::spawn( move || {
      for i in 0..10 { 
        println!("thread {} begins",i);
        thread::sleep(Duration::from_millis(50));
        println!("thread {} ends",i);
      }
    }); 
    thread::sleep(Duration::from_millis(100));
    let result = fetch_data().await;
    println!("{}", result);
}


