
use std::sync::{Arc, Mutex};
use std::thread;
use std::time::Duration;

fn main() {
    // Wrap a mutable integer in an Arc and a Mutex for shared access
    let counter = Arc::new(Mutex::new(0));

    // Create two threads that will both increment the counter
    let handles: Vec<_> = (0..2)
        .map(|_| {
            let counter = Arc::clone(&counter);

            thread::spawn(move || {
                // Unsafe block allowing mutable reference access
                thread::sleep(Duration::from_millis(700));
                unsafe {
                    let ptr = &*counter as *const Mutex<i32> as *mut Mutex<i32>;
                    for _ in 0..3000 {
                        // Dereference the raw pointer to access the Mutex
                        let mut num = (*ptr).lock().unwrap();
                        *num += 1;
                    }
                }
            })
        })
        .collect();

    for handle in handles {
        handle.join().unwrap();
    }

    println!("Result: {}", *counter.lock().unwrap());
}
