
use std::sync::{Arc, Mutex};
use std::thread;
use std::time::Duration;

fn main() {
    // Create an Arc and Mutex to wrap the shared variable
    let shared_data = Arc::new(Mutex::new(0));

    let shared_data_clone1 = Arc::clone(&shared_data);
    let thread1 = thread::spawn(move || {
        for _ in 0..5 {
            thread::sleep(Duration::from_millis(800));
            let mut data = shared_data_clone1.lock().unwrap(); // Lock the mutex
            *data += 1; // Increment the shared variable
            println!("Thread 1: {}", *data);
        }
    });

    let shared_data_clone2 = Arc::clone(&shared_data);
    let thread2 = thread::spawn(move || {
        for _ in 0..5 {
            thread::sleep(Duration::from_millis(400));
            let mut data = shared_data_clone2.lock().unwrap(); // Lock the mutex
            *data += 1; // Increment the shared variable
            println!("Thread 2: {}", *data);
        }
    });

    // Wait for both threads to finish
    thread1.join().unwrap();
    thread2.join().unwrap();

    println!("Final value: {}", *shared_data.lock().unwrap());
}

